#define EN1 6//右侧电机使能引脚
#define IN1 7//右侧电机方向引脚
#define EN2 5//左侧电机使能引脚
#define IN2 4//左侧电机方向引脚

#define FORW 1//前进
#define BACK 0//后退

#define IR_IN  8//红外接收
#define L_IR 9//左红外发送
#define R_IR 10//右红外发送

int count;//对返回的脉冲进行计数

void Motor_Control(int M1_DIR,int M1_EN,int M2_DIR,int M2_EN)//控制电机转动
{
  //////////M1////////////////////////
  if(M1_DIR==FORW)//M1电机方向  
    digitalWrite(IN1,FORW);//设置方向向前
  else
    digitalWrite(IN1,BACK);//设置方向向后   
  if(M1_EN==0)//M1电机速度 
    analogWrite(EN1,LOW);//置低，停止
  else
    analogWrite(EN1,M1_EN);//设置给定的数值

  ///////////M2//////////////////////
  if(M2_DIR==FORW)//M2电机的方向  
    digitalWrite(IN2,FORW);//设置方向向前 
  else
    digitalWrite(IN2,BACK);//设置方向向后   
  if(M2_EN==0) //M2电机的速度
    analogWrite(EN2,LOW);//置低，停止
  else
    analogWrite(EN2,M2_EN); //设置给定的数值
}
void L_Send40KHZ(void)//左发射管发射频率为40kHZ脉冲
{
  int i;
  for(i=0;i<24;i++)
  {
    digitalWrite(L_IR,LOW);//置低，导通
    delayMicroseconds(8);//延时
    digitalWrite(L_IR,HIGH);//置高，截止
    delayMicroseconds(8);//延时
  }
}
void R_Send40KHZ(void)//右发射管发射频率为40kHZ脉冲
{
  int i;
  for(i=0;i<24;i++)
  {
    digitalWrite(R_IR,LOW);//置低，导通
    delayMicroseconds(8);//延时
    digitalWrite(R_IR,HIGH);//置低，截止
    delayMicroseconds(8);//延时
  }
}
void pcint0_init(void)//引脚变化中断初始化
{
  PCICR = 0X01;//使能第0组引脚变化中断
  PCMSK0 = 0X01;//使能第0组的第0个引脚变化中断
}

ISR(PCINT0_vect)//PB0引脚变化中断
{
  count++;//对接收到的脉冲计数
}
//查找节点
void node(void)
{
     Serial.print(126,BYTE);//7E
     Serial.print(0,BYTE);//00
     Serial.print(4,BYTE);//04
     Serial.print(8,BYTE);//08
     Serial.print(9,BYTE);//09
     Serial.print(78,BYTE);//4E
     Serial.print(68,BYTE);//44
     Serial.print(92,BYTE);//5C
     
}
//向模块B发送字符L
void sendB_L(void)
{
     Serial.print(126,BYTE);//7E
     
     //有效数据长度
     Serial.print(0,BYTE);//00
     Serial.print(15,BYTE);//0F
     
     Serial.print(16,BYTE);//10
     Serial.print(1,BYTE);//01
     
     //目的地地址（即B模块的地址）
     Serial.print(0,BYTE);//00
     Serial.print(19,BYTE);//13
     Serial.print(162,BYTE);//A2
     Serial.print(0,BYTE);//00
     Serial.print(64,BYTE);//40
     Serial.print(111,BYTE);//6F
     Serial.print(183,BYTE);//B7
     Serial.print(111,BYTE);//6F
     
     Serial.print(255,BYTE);//FF
     Serial.print(254,BYTE);//FE
     Serial.print(0,BYTE);//00
     Serial.print(0,BYTE);//00
     
     //要发送的内容
     Serial.print(76,BYTE);//4C L
     
     //校验和
     Serial.print(27,BYTE);//1B    
}
//向模块B发送字符R
void sendB_R(void)
{
     Serial.print(126,BYTE);//7E
     
     //有效数据长度
     Serial.print(0,BYTE);//00
     Serial.print(15,BYTE);//0F
     
     Serial.print(16,BYTE);//10
     Serial.print(1,BYTE);//01
     
     //目的地地址（即B模块的地址）
     Serial.print(0,BYTE);//00
     Serial.print(19,BYTE);//13
     Serial.print(162,BYTE);//A2
     Serial.print(0,BYTE);//00
     Serial.print(64,BYTE);//40
     Serial.print(111,BYTE);//6F
     Serial.print(183,BYTE);//B7
     Serial.print(111,BYTE);//6F
     
     Serial.print(255,BYTE);//FF
     Serial.print(254,BYTE);//FE
     Serial.print(0,BYTE);//00
     Serial.print(0,BYTE);//00
     
     //要发送的内容
     Serial.print(82,BYTE);//52 R
     
     //校验和
     Serial.print(21,BYTE);//15  
}
//向模块C发送字符L
void sendC_L(void)
{
     Serial.print(126,BYTE);//7E
     
     //有效数据长度
     Serial.print(0,BYTE);//00
     Serial.print(15,BYTE);//0F
     
     Serial.print(16,BYTE);//10
     Serial.print(1,BYTE);//01
     
     //目的地地址（即C模块的地址）
     Serial.print(0,BYTE);//00
     Serial.print(19,BYTE);//13
     Serial.print(162,BYTE);//A2
     Serial.print(0,BYTE);//00
     Serial.print(64,BYTE);//40
     Serial.print(111,BYTE);//6F
     Serial.print(183,BYTE);//B7
     Serial.print(127,BYTE);//7F
     
     Serial.print(255,BYTE);//FF
     Serial.print(254,BYTE);//FE
     Serial.print(0,BYTE);//00
     Serial.print(0,BYTE);//00
     
     //要发送的内容
     Serial.print(76,BYTE);//4C L

     
     //校验和
     Serial.print(11,BYTE);//B
}
//向模块C发送字符R
void sendC_R(void)
{
     Serial.print(126,BYTE);//7E
     
     //有效数据长度
     Serial.print(0,BYTE);//00
     Serial.print(15,BYTE);//0F
     
     Serial.print(16,BYTE);//10
     Serial.print(1,BYTE);//01
     
     //目的地地址（即C模块的地址）
     Serial.print(0,BYTE);//00
     Serial.print(19,BYTE);//13
     Serial.print(162,BYTE);//A2
     Serial.print(0,BYTE);//00
     Serial.print(64,BYTE);//40
     Serial.print(111,BYTE);//6F
     Serial.print(183,BYTE);//B7
     Serial.print(127,BYTE);//7F
     
     Serial.print(255,BYTE);//FF
     Serial.print(254,BYTE);//FE
     Serial.print(0,BYTE);//00
     Serial.print(0,BYTE);//00
     
     //要发送的内容
      Serial.print(82,BYTE);//52 R
     
     //校验和
     Serial.print(5,BYTE);//05 
}
void Obstacle_Avoidance(void)
{
  char i;
  count=0;
  for(i=0;i<20;i++)//左发射管发射20个脉冲
  {
    L_Send40KHZ();
    delayMicroseconds(600);    
  }
  if(count>20)//如果接收超过了10个脉冲，判断有障碍物 
  {
    sendB_L();
    sendC_L();
    Motor_Control(BACK,100,FORW,100);//右转
    delay(50);//延时
  }
  else
  {
    count=0;
    for(i=0;i<20;i++)//右发射管发射20个脉冲
    {
      R_Send40KHZ(); 
      delayMicroseconds(600);        
    }
    if(count>20)
    {
      sendB_R();
      sendC_R();
      Motor_Control(FORW,100,BACK,100);//左转
      delay(50);//延时
    }
    else
    {
      Motor_Control(FORW,0,FORW,0);//前进
    }
  }

}
void setup()
{  
  char i;
  for(i=4;i<=7;i++)//设置控制两组电机的四个引脚为输出
  {
    pinMode(i,OUTPUT);
  }
  pinMode(L_IR,OUTPUT);//连接左发射管的引脚为输出
  pinMode(R_IR,OUTPUT);//连接右发射管的引脚为输出
  pinMode(IR_IN,INPUT);//连接红外线接收的引脚为输入
  digitalWrite(R_IR,HIGH);
  digitalWrite(L_IR,HIGH);
  
  Serial.begin(38400); //设置波特率
   
  pcint0_init();//引脚变化中断初始化
  sei();     //全局中断使能
  node();
  delay(1000);
}
void loop()
{
    while(1)
   {
      Obstacle_Avoidance();
   }  
}
