#define EN1 6//右侧电机使能引脚
#define IN1 7//右侧电机方向引脚
#define EN2 5//左侧电机使能引脚
#define IN2 4//左侧电机方向引脚

#define FORW 1//前进
#define BACK 0//后退

#define IR_IN  8//红外接收
#define L_IR 9//左红外发送
#define R_IR 10//右红外发送

void Motor_Control(int M1_DIR,int M1_EN,int M2_DIR,int M2_EN)//控制电机转动
{
  //////////M1////////////////////////
  if(M1_DIR==FORW)//M1电机方向  
    digitalWrite(IN1,FORW);//设置方向向前
  else
    digitalWrite(IN1,BACK);//设置方向向后   
  if(M1_EN==0)//M1电机速度 
    analogWrite(EN1,LOW);//置低，停止
  else
    analogWrite(EN1,M1_EN);//设置给定的数值

  ///////////M2//////////////////////
  if(M2_DIR==FORW)//M2电机的方向  
    digitalWrite(IN2,FORW);//设置方向向前 
  else
    digitalWrite(IN2,BACK);//设置方向向后   
  if(M2_EN==0) //M2电机的速度
    analogWrite(EN2,LOW);//置低，停止
  else
    analogWrite(EN2,M2_EN); //设置给定的数值
}

void node(void)
{
     Serial.print(126,BYTE);//7E
     Serial.print(0,BYTE);//00
     Serial.print(4,BYTE);//04
     Serial.print(8,BYTE);//08
     Serial.print(9,BYTE);//09
     Serial.print(78,BYTE);//4E
     Serial.print(68,BYTE);//44
     Serial.print(92,BYTE);//5C
}
void setup()
{
  char i;
  for(i=4;i<=7;i++)//设置控制两组电机的四个引脚为输出
  {
    pinMode(i,OUTPUT);
  }
   pinMode(12,OUTPUT);//红灯
   digitalWrite(12,LOW);
   Serial.begin(38400); //设置波特率
   
   node();
   delay(1000);   
}
void loop()
{
     int temp_char;
     int start_flag = 0;
     int data_index=0; 
     int com_index=0; 
     int data[17];
     int dataLen = 0;     
     int SUM;
     int i;
     int state;
     
     while(1)
     {
        temp_char = Serial.read();
        if(temp_char!=-1)
        {
           if(start_flag==0)
           {
              if(temp_char == 126)
              {
                  start_flag=1;
                  data[0]=126;
                  data_index = 0;	
      	          com_index = 0;
              }
           }
           else if(com_index<2)
           {
                switch(com_index)
                {
                  
                    case 0: data[1]=temp_char;
                            break;
                    case 1: data[2]=temp_char;
                            dataLen=(data[1]*256)+data[2];
                            break;
                }
                com_index++;
           }
           else if(data_index < dataLen)
           {
                data[data_index+3]=temp_char;
                data_index++;
           }
           else
           {
                data[16]=temp_char;
                state=1;   //一帧接收完毕
                start_flag = 0;//清标志
           }
        }
        if(state==1)
        {
           state=0;
           SUM=0;
           for(i=3;i<16;i++)SUM+=data[i];
           SUM%=256;
           SUM=255-SUM;
           if(SUM==data[16])
           {
              if(data[15]=='L')//接收到字符L说明左边有障碍物
              {
                  Motor_Control(BACK,100,FORW,100);//右转
                  delay(60);//延时
                  Motor_Control(BACK,0,FORW,0);//停止
                  delay(60);//延时
              }
              else if(data[15]=='R')//接收到字符R说明右边有障碍物
              {
                  Motor_Control(FORW,100,BACK,100);//左转
                  delay(60);//延时
                  Motor_Control(BACK,0,FORW,0);//停止
                  delay(60);//延时
              }
           }
        }
     }
}
